
#include "stm32f4xx_it.h"

uint8_t CONVERSIONS_COUNT = 10;
uint16_t ADC_CONVERSIONS[10] = {0};


/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
}

/**
  * @brief  This function handles PPP interrupt request.
  * @param  None
  * @retval None
  */
/*void PPP_IRQHandler(void)
{
}*/

void  EXTI0_IRQHandler(void) {
	TIM_Cmd(TIM5, ENABLE);
	EXTI_ClearITPendingBit(EXTI_Line0);
}


void DMA2_Stream4_IRQHandler(void) {

	if(DMA_GetITStatus(DMA2_Stream4, DMA_IT_HTIF4) != RESET) {
		DMA_ClearITPendingBit(DMA2_Stream4, DMA_IT_HTIF4);
		uint8_t bitState=GPIO_ReadOutputDataBit(GPIOD, GPIO_Pin_12);
		GPIO_WriteBit(GPIOD, GPIO_Pin_12, 1-bitState);
	}

	if(DMA_GetITStatus(DMA2_Stream4, DMA_IT_TCIF4) != RESET) {
		DMA_ClearITPendingBit(DMA2_Stream4, DMA_IT_TCIF4);
		TIM_Cmd(TIM5, DISABLE);
		uint8_t bitState=GPIO_ReadOutputDataBit(GPIOD, GPIO_Pin_12);
		GPIO_WriteBit(GPIOD, GPIO_Pin_12, 1-bitState);
		uint16_t res = 0;
		uint8_t i = 0;
		for(i=0; i<CONVERSIONS_COUNT; i++)
			res+=ADC_CONVERSIONS[i]>>4;
		res/=CONVERSIONS_COUNT;
		DAC_SetChannel1Data(DAC_Align_12b_R, res);

	}
}
